> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# List data model sources

GET https://api.sigmacomputing.com/v2/dataModels/{dataModelId}/sources

List data sources of a data model given the dataModelId. The response can be a dataset (deprecated), table, custom SQL element, or the data model document and specific elements used as a source.

  ### Usage notes
  - Retrieve the **dataModelId** by calling the [/v2/dataModels](https://help.sigmacomputing.com/reference/list-data-models) endpoint.

Reference: https://help.sigmacomputing.com/reference/list-data-model-sources

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/dataModels/{dataModelId}/sources:
    get:
      operationId: listDataModelSources
      summary: List data model sources
      description: >-
        List data sources of a data model given the dataModelId. The response
        can be a dataset (deprecated), table, custom SQL element, or the data
        model document and specific elements used as a source.

          ### Usage notes
          - Retrieve the **dataModelId** by calling the [/v2/dataModels](https://help.sigmacomputing.com/reference/list-data-models) endpoint.
      tags:
        - dataModels
      parameters:
        - name: dataModelId
          in: path
          required: true
          schema:
            type: string
        - name: pageToken
          in: query
          required: false
          schema:
            type: string
        - name: pageSize
          in: query
          required: false
          schema:
            type: integer
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/dataModels_listDataModelSources_Response_200
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf0Type:
      type: string
      enum:
        - data-model
      title: >-
        V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf0Type
    V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItems0:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf0Type
        dataModelId:
          type: string
        elementIds:
          type: array
          items:
            type: string
          description: IDs of elements that make up this data model’s sources.
        versionTagId:
          type: string
      required:
        - type
        - dataModelId
        - elementIds
      title: >-
        V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItems0
    V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf1Type:
      type: string
      enum:
        - dataset
      title: >-
        V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf1Type
    V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItems1:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf1Type
        datasetId:
          type: string
      required:
        - type
        - datasetId
      title: >-
        V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItems1
    V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf2Type:
      type: string
      enum:
        - table
      title: >-
        V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf2Type
    V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItems2:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf2Type
        tableId:
          type: string
      required:
        - type
        - tableId
      title: >-
        V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItems2
    V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf3Type:
      type: string
      enum:
        - custom-sql
      title: >-
        V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf3Type
    V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItems3:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItemsOneOf3Type
        connectionId:
          type: string
          description: ID of the connection where the custom SQL element is run.
        definition:
          type: string
          description: Raw SQL definition for the custom SQL element.
        customSqlId:
          type: string
          description: Element ID of the custom SQL.
      required:
        - type
        - connectionId
        - definition
        - customSqlId
      title: >-
        V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItems3
    V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItems:
      oneOf:
        - $ref: >-
            #/components/schemas/V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItems0
        - $ref: >-
            #/components/schemas/V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItems1
        - $ref: >-
            #/components/schemas/V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItems2
        - $ref: >-
            #/components/schemas/V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItems3
      title: >-
        V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItems
    dataModels_listDataModelSources_Response_200:
      type: object
      properties:
        entries:
          type: array
          items:
            $ref: >-
              #/components/schemas/V2DataModelsDataModelIdSourcesGetResponsesContentApplicationJsonSchemaEntriesItems
          description: Array of results returned by the endpoint
        nextPageToken:
          type: string
          description: >-
            A string that can be passed to the `pageToken` parameter in the next
            request to fetch the next page of results. Not present in the last
            page of results.

            **Must be treated as an opaque string.**
      required:
        - entries
      title: dataModels_listDataModelSources_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Request**

```json
{}
```

**Response**

```json
{
  "entries": [
    {
      "dataModelId": "dm_8f3a2c9b-4e7d-4a1e-bf3d-2c9a7e5f1d3b",
      "elementIds": [
        "elem_12345abcde",
        "elem_67890fghij"
      ],
      "type": "data-model",
      "versionTagId": "vtag_202406"
    }
  ],
  "nextPageToken": "eyJwYWdlIjoxfQ=="
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/dataModels/dataModelId/sources"

payload = {}
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.get(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/dataModels/dataModelId/sources';
const options = {
  method: 'GET',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/dataModels/dataModelId/sources"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("GET", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/dataModels/dataModelId/sources")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.sigmacomputing.com/v2/dataModels/dataModelId/sources")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.sigmacomputing.com/v2/dataModels/dataModelId/sources', [
  'body' => '{}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/dataModels/dataModelId/sources");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/dataModels/dataModelId/sources")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```